#pragma once

#include <iostream>

using namespace std;

class V3 {
  float xyz[3];
public:
  V3(float x, float y, float z);
  V3() {};
  // cross product
  V3 operator^(V3 op1);
  // dot product
  float operator*(V3 op1);
  V3 operator+(V3 op1);
  V3 operator-(V3 op1);
  float& operator[](int i);
  float Length();
  friend ostream& operator<<(ostream &ostr, V3 v);
  V3 operator/(float scf);
};